<!DOCTYPE HTML>
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (11.0.8) on Wed Aug 12 16:32:57 CEST 2020 -->
<title>INbaAccess</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="dc.created" content="2020-08-12">
<link rel="stylesheet" type="text/css" href="../../../../stylesheet.css" title="Style">
<link rel="stylesheet" type="text/css" href="../../../../jquery/jquery-ui.css" title="Style">
<script type="text/javascript" src="../../../../script.js"></script>
<script type="text/javascript" src="../../../../jquery/jszip/dist/jszip.min.js"></script>
<script type="text/javascript" src="../../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
<!--[if IE]>
<script type="text/javascript" src="../../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
<![endif]-->
<script type="text/javascript" src="../../../../jquery/jquery-3.3.1.js"></script>
<script type="text/javascript" src="../../../../jquery/jquery-migrate-3.0.1.js"></script>
<script type="text/javascript" src="../../../../jquery/jquery-ui.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="INbaAccess";
        }
    }
    catch(err) {
    }
//-->
var data = {"i0":6,"i1":6,"i2":6,"i3":6,"i4":6,"i5":6,"i6":6,"i7":6,"i8":6,"i9":6,"i10":6};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],4:["t3","Abstract Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
var pathtoroot = "../../../../";
var useModuleDirectories = true;
loadScripts(document, 'script');</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<header role="banner">
<nav role="navigation">
<div class="fixedNav">
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a id="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/INbaAccess.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<ul class="navListSearch">
<li><label for="search">SEARCH:</label>
<input type="text" id="search" value="search" disabled="disabled">
<input type="reset" id="reset" value="reset" disabled="disabled">
</li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
</div>
<div class="navPadding">&nbsp;</div>
<script type="text/javascript"><!--
$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
//-->
</script>
</nav>
</header>
<!-- ======== START OF CLASS DATA ======== -->
<main role="main">
<div class="header">
<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">nl.naturalis.nba.api</a></div>
<h2 title="Interface INbaAccess" class="title">Interface INbaAccess&lt;DOCUMENT_OBJECT extends <a href="model/IDocumentObject.html" title="interface in nl.naturalis.nba.api.model">IDocumentObject</a>&gt;</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>DOCUMENT_OBJECT</code> - The class representing the Elasticsearch document
        that you are given access to.</dd>
</dl>
<dl>
<dt>All Known Subinterfaces:</dt>
<dd><code><a href="IGeoAreaAccess.html" title="interface in nl.naturalis.nba.api">IGeoAreaAccess</a></code>, <code><a href="IMultiMediaObjectAccess.html" title="interface in nl.naturalis.nba.api">IMultiMediaObjectAccess</a></code>, <code><a href="ISpecimenAccess.html" title="interface in nl.naturalis.nba.api">ISpecimenAccess</a></code>, <code><a href="ITaxonAccess.html" title="interface in nl.naturalis.nba.api">ITaxonAccess</a></code></dd>
</dl>
<hr>
<pre>public interface <span class="typeNameLabel">INbaAccess&lt;DOCUMENT_OBJECT extends <a href="model/IDocumentObject.html" title="interface in nl.naturalis.nba.api.model">IDocumentObject</a>&gt;</span></pre>
<div class="block">Specifies a set of common data access methods that can be called against any
 type of document within the NBA document store.</div>
<dl>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd>Ayco Holleman</dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ========== METHOD SUMMARY =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t3" class="tableTab"><span><a href="javascript:show(4);">Abstract Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Method</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code><a href="BatchQueryResult.html" title="class in nl.naturalis.nba.api">BatchQueryResult</a>&lt;<a href="INbaAccess.html" title="type parameter in INbaAccess">DOCUMENT_OBJECT</a>&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#batchQuery(java.lang.String)">batchQuery</a></span>&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/String.html?is-external=true" title="class or interface in java.lang" class="externalLink">String</a>&nbsp;token)</code></th>
<td class="colLast">
<div class="block">Retrieves the next batch of documents using the specified token.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code><a href="BatchQueryResult.html" title="class in nl.naturalis.nba.api">BatchQueryResult</a>&lt;<a href="INbaAccess.html" title="type parameter in INbaAccess">DOCUMENT_OBJECT</a>&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#batchQuery(nl.naturalis.nba.api.QuerySpec)">batchQuery</a></span>&#8203;(<a href="QuerySpec.html" title="class in nl.naturalis.nba.api">QuerySpec</a>&nbsp;querySpec)</code></th>
<td class="colLast">
<div class="block">
 Returns documents satisfying the provided query.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>long</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#count(nl.naturalis.nba.api.QuerySpec)">count</a></span>&#8203;(<a href="QuerySpec.html" title="class in nl.naturalis.nba.api">QuerySpec</a>&nbsp;querySpec)</code></th>
<td class="colLast">
<div class="block">
 Returns the number of documents conforming to the provided query
 specification.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>long</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#countDistinctValues(java.lang.String,nl.naturalis.nba.api.QuerySpec)">countDistinctValues</a></span>&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/String.html?is-external=true" title="class or interface in java.lang" class="externalLink">String</a>&nbsp;field,
                   <a href="QuerySpec.html" title="class in nl.naturalis.nba.api">QuerySpec</a>&nbsp;querySpec)</code></th>
<td class="colLast">
<div class="block">
 Returns the distinct number of values for the given field.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code><a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/util/List.html?is-external=true" title="class or interface in java.util" class="externalLink">List</a>&lt;<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/util/Map.html?is-external=true" title="class or interface in java.util" class="externalLink">Map</a>&lt;<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/String.html?is-external=true" title="class or interface in java.lang" class="externalLink">String</a>,&#8203;<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/Object.html?is-external=true" title="class or interface in java.lang" class="externalLink">Object</a>&gt;&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#countDistinctValuesPerGroup(java.lang.String,java.lang.String,nl.naturalis.nba.api.QuerySpec)">countDistinctValuesPerGroup</a></span>&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/String.html?is-external=true" title="class or interface in java.lang" class="externalLink">String</a>&nbsp;forGroup,
                           <a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/String.html?is-external=true" title="class or interface in java.lang" class="externalLink">String</a>&nbsp;forField,
                           <a href="QuerySpec.html" title="class in nl.naturalis.nba.api">QuerySpec</a>&nbsp;querySpec)</code></th>
<td class="colLast">
<div class="block">
 Returns the distinct number of values for the given field (<i>forField</i>),
 grouped by the second field (<i>forGroup</i>) you have specified.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#downloadQuery(nl.naturalis.nba.api.QuerySpec,java.io.OutputStream)">downloadQuery</a></span>&#8203;(<a href="QuerySpec.html" title="class in nl.naturalis.nba.api">QuerySpec</a>&nbsp;querySpec,
             <a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/io/OutputStream.html?is-external=true" title="class or interface in java.io" class="externalLink">OutputStream</a>&nbsp;out)</code></th>
<td class="colLast">
<div class="block">
 Writes the output satisfying the specified query specification to the
 specified output stream.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code><a href="INbaAccess.html" title="type parameter in INbaAccess">DOCUMENT_OBJECT</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#find(java.lang.String)">find</a></span>&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/String.html?is-external=true" title="class or interface in java.lang" class="externalLink">String</a>&nbsp;id)</code></th>
<td class="colLast">
<div class="block">
 Returns the document with the specified document ID, or <code>null</code> if there
 is no document with the specified document ID.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code><a href="INbaAccess.html" title="type parameter in INbaAccess">DOCUMENT_OBJECT</a>[]</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#findByIds(java.lang.String%5B%5D)">findByIds</a></span>&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/String.html?is-external=true" title="class or interface in java.lang" class="externalLink">String</a>[]&nbsp;ids)</code></th>
<td class="colLast">
<div class="block">
 Returns the data model objects with the specified system IDs, or a
 zero-length array no specimens were found.</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code><a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/util/Map.html?is-external=true" title="class or interface in java.util" class="externalLink">Map</a>&lt;<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/String.html?is-external=true" title="class or interface in java.lang" class="externalLink">String</a>,&#8203;<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/Long.html?is-external=true" title="class or interface in java.lang" class="externalLink">Long</a>&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getDistinctValues(java.lang.String,nl.naturalis.nba.api.QuerySpec)">getDistinctValues</a></span>&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/String.html?is-external=true" title="class or interface in java.lang" class="externalLink">String</a>&nbsp;forField,
                 <a href="QuerySpec.html" title="class in nl.naturalis.nba.api">QuerySpec</a>&nbsp;querySpec)</code></th>
<td class="colLast">
<div class="block">
 Returns the unique values of the specified field.</div>
</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code><a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/util/List.html?is-external=true" title="class or interface in java.util" class="externalLink">List</a>&lt;<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/util/Map.html?is-external=true" title="class or interface in java.util" class="externalLink">Map</a>&lt;<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/String.html?is-external=true" title="class or interface in java.lang" class="externalLink">String</a>,&#8203;<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/Object.html?is-external=true" title="class or interface in java.lang" class="externalLink">Object</a>&gt;&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getDistinctValuesPerGroup(java.lang.String,java.lang.String,nl.naturalis.nba.api.QuerySpec)">getDistinctValuesPerGroup</a></span>&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/String.html?is-external=true" title="class or interface in java.lang" class="externalLink">String</a>&nbsp;forGroup,
                         <a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/String.html?is-external=true" title="class or interface in java.lang" class="externalLink">String</a>&nbsp;forField,
                         <a href="QuerySpec.html" title="class in nl.naturalis.nba.api">QuerySpec</a>&nbsp;querySpec)</code></th>
<td class="colLast">
<div class="block">
 Returns the distinct values and their document count of the specified field
 (<i>forField</i>), grouped by a second specified field (<i>forGroup</i>).</div>
</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code><a href="QueryResult.html" title="class in nl.naturalis.nba.api">QueryResult</a>&lt;<a href="INbaAccess.html" title="type parameter in INbaAccess">DOCUMENT_OBJECT</a>&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#query(nl.naturalis.nba.api.QuerySpec)">query</a></span>&#8203;(<a href="QuerySpec.html" title="class in nl.naturalis.nba.api">QuerySpec</a>&nbsp;querySpec)</code></th>
<td class="colLast">
<div class="block">
 Returns documents satisfying the provided query.</div>
</td>
</tr>
</table>
</li>
</ul>
</section>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a id="find(java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>find</h4>
<pre class="methodSignature"><a href="INbaAccess.html" title="type parameter in INbaAccess">DOCUMENT_OBJECT</a>&nbsp;find&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/String.html?is-external=true" title="class or interface in java.lang" class="externalLink">String</a>&nbsp;id)</pre>
<div class="block"><p>
 Returns the document with the specified document ID, or <code>null</code> if there
 is no document with the specified document ID. Note that the document ID is
 not part of the document itself. It corresponds with the Elasticsearch
 <code>_id</code> field, which is retrieved separately from the document source.
 You can get the value of this field through <a href="model/IDocumentObject.html#getId()"><code>IDocumentObject.getId</code></a>.
 </p>
 <h5>REST API</h5>
 <p>
 The NBA REST API exposes this method through a GET request with the following
 end point:
 </p>
 <p>
 <code>
 https://api.biodiversitydata.nl/v2/&lt;document-type&gt;/find/{id}
 </code>
 </p>
 <p>
 For example:
 </p>
 <p>
 <code>
 https://api.biodiversitydata.nl/v2/specimen/find/ZMA.MAM.123456@CRS
 </code>
 </p></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>id</code> - The NBA system ID of the data model object</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="model/IDocumentObject.html" title="interface in nl.naturalis.nba.api.model"><code>IDocumentObject</code></a></dd>
</dl>
</li>
</ul>
<a id="findByIds(java.lang.String[])">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>findByIds</h4>
<pre class="methodSignature"><a href="INbaAccess.html" title="type parameter in INbaAccess">DOCUMENT_OBJECT</a>[]&nbsp;findByIds&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/String.html?is-external=true" title="class or interface in java.lang" class="externalLink">String</a>[]&nbsp;ids)</pre>
<div class="block"><p>
 Returns the data model objects with the specified system IDs, or a
 zero-length array no specimens were found. Note that you cannot look up more
 than 1024 IDs at a time.
 </p>
 <h5>REST API</h5>
 <p>
 The NBA REST API exposes this method through a GET request with the following
 end point:
 </p>
 <p>
 <code>
 https://api.biodiversitydata.nl/v2/&lt;document-type&gt;/findByIds/{id-0},{id-1},{id-2},{id-n}
 </code>
 </p>
 <p>
 For example:
 </p>
 <p>
 <code>
 https://api.biodiversitydata.nl/v2/specimen/findByIds/ZMA.MAM.123,ZMA.MAM.456,ZMA.MAM.789
 </code>
 </p></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>id</code> - The NBA system IDs of the requested data model objects</dd>
<dt><span class="returnLabel">Returns:</span></dt>
</dl>
</li>
</ul>
<a id="query(nl.naturalis.nba.api.QuerySpec)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>query</h4>
<pre class="methodSignature"><a href="QueryResult.html" title="class in nl.naturalis.nba.api">QueryResult</a>&lt;<a href="INbaAccess.html" title="type parameter in INbaAccess">DOCUMENT_OBJECT</a>&gt;&nbsp;query&#8203;(<a href="QuerySpec.html" title="class in nl.naturalis.nba.api">QuerySpec</a>&nbsp;querySpec)
                            throws <a href="InvalidQueryException.html" title="class in nl.naturalis.nba.api">InvalidQueryException</a></pre>
<div class="block"><p>
 Returns documents satisfying the provided query.
 </p>
 <h5>REST API</h5>
 <p>
 The NBA REST API exposes this method through a GET and a POST request with
 the following endpoint:
 </p>
 <p>
 <code>
 https://api.biodiversitydata.nl/v2/&lt;document-type&gt;/query
 </code>
 </p>
 <p>
 See <a href="QuerySpec.html" title="class in nl.naturalis.nba.api"><code>QuerySpec</code></a> for an explanation of how to encode the
 <code>QuerySpec</code> object in the request.
 </p></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>querySpec</code> - </dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="InvalidQueryException.html" title="class in nl.naturalis.nba.api">InvalidQueryException</a></code></dd>
</dl>
</li>
</ul>
<a id="batchQuery(nl.naturalis.nba.api.QuerySpec)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>batchQuery</h4>
<pre class="methodSignature"><a href="BatchQueryResult.html" title="class in nl.naturalis.nba.api">BatchQueryResult</a>&lt;<a href="INbaAccess.html" title="type parameter in INbaAccess">DOCUMENT_OBJECT</a>&gt;&nbsp;batchQuery&#8203;(<a href="QuerySpec.html" title="class in nl.naturalis.nba.api">QuerySpec</a>&nbsp;querySpec)
                                      throws <a href="InvalidQueryException.html" title="class in nl.naturalis.nba.api">InvalidQueryException</a></pre>
<div class="block"><p>
 Returns documents satisfying the provided query. This method is meant to be
 the first call for a batch-wise retrieval operation. The query result will
 contain a resumption token to be used for subsequent calls (see
 <a href="#batchQuery(java.lang.String)"><code>batchQuery(String)</code></a>). The resumption token is already URL-encoded so
 can be used straight away as the value for the <code>_token</code> query
 parameter. Make sure it doesn't get accidentally URL-encoded again.
 <p>
 Unlike the <a href="#query(nl.naturalis.nba.api.QuerySpec)"><code>query</code></a> method, this method is meant to
 retrieve large datasets in batches. You could do the same with the
 <code>query</code> method by repeatedly increasing the <a href="QuerySpec.html#getFrom()"><code>from</code></a> field in the <code>QuerySpec</code>, but this gradually becomes very
 expensive and you will eventually hit a brick wall beyond which the NBA which
 won't let you go.
 <p>
 With the <code>batchQuery</code> service the <code>from</code> and <code>sort</code> fields
 of the <code>QuerySpec</code> are ignored. Sorting is done in an
 implementation-specific way. Also, for perfomance reasons, no document total
 is given in the query result. The presence of a resumption token means there
 are more records to retrieve. You are free to specify the batch size using
 <code>size</code> field of the <code>QuerySpec</code>, but there is a hard limit of
 5000 documents per batch.
 </p>
 <h5>REST API</h5>
 <p>
 The NBA REST API exposes this method through a GET and a POST request with
 the following endpoint:
 </p>
 <p>
 <code>
 https://api.biodiversitydata.nl/v2/&lt;document-type&gt;/batchQuery
 </code>
 </p>
 <p>
 See <a href="QuerySpec.html" title="class in nl.naturalis.nba.api"><code>QuerySpec</code></a> for an explanation of how to encode the
 <code>QuerySpec</code> object in the request.
 </p></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>querySpec</code> - </dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="InvalidQueryException.html" title="class in nl.naturalis.nba.api">InvalidQueryException</a></code></dd>
</dl>
</li>
</ul>
<a id="batchQuery(java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>batchQuery</h4>
<pre class="methodSignature"><a href="BatchQueryResult.html" title="class in nl.naturalis.nba.api">BatchQueryResult</a>&lt;<a href="INbaAccess.html" title="type parameter in INbaAccess">DOCUMENT_OBJECT</a>&gt;&nbsp;batchQuery&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/String.html?is-external=true" title="class or interface in java.lang" class="externalLink">String</a>&nbsp;token)
                                      throws <a href="InvalidQueryException.html" title="class in nl.naturalis.nba.api">InvalidQueryException</a></pre>
<div class="block">Retrieves the next batch of documents using the specified token. The token
 should be obtained from the <code>BatchQueryResult</code> returned by the
 <a href="#batchQuery(nl.naturalis.nba.api.QuerySpec)"><code>initial query</code></a> or by a previous call to
 <i>this</i> method.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>resumptionToken</code> - </dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="InvalidQueryException.html" title="class in nl.naturalis.nba.api">InvalidQueryException</a></code></dd>
</dl>
</li>
</ul>
<a id="downloadQuery(nl.naturalis.nba.api.QuerySpec,java.io.OutputStream)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>downloadQuery</h4>
<pre class="methodSignature">void&nbsp;downloadQuery&#8203;(<a href="QuerySpec.html" title="class in nl.naturalis.nba.api">QuerySpec</a>&nbsp;querySpec,
                   <a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/io/OutputStream.html?is-external=true" title="class or interface in java.io" class="externalLink">OutputStream</a>&nbsp;out)
            throws <a href="InvalidQueryException.html" title="class in nl.naturalis.nba.api">InvalidQueryException</a>,
                   <a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/io/IOException.html?is-external=true" title="class or interface in java.io" class="externalLink">IOException</a></pre>
<div class="block"><p>
 Writes the output satisfying the specified query specification to the
 specified output stream.
 </p>
 <h5>REST API</h5>
 <p>
 The NBA REST API exposes this method through a GET and POST request with the
 following end point:
 </p>
 <p>
 <code>
 https://api.biodiversitydata.nl/v2/&lt;document-type&gt;/download/{querySpec}
 </code>
 </p>
 <p>
 For example:
 </p>
 <p>
 <code>
 https://api.biodiversitydata.nl/v2/specimen/download/?identifications.scientificName.fullScientificName=Limosa%20limosa
 </code>
 </p>
 <p>
 See <a href="QuerySpec.html" title="class in nl.naturalis.nba.api"><code>QuerySpec</code></a> for an explanation of how to encode the
 <code>QuerySpec</code> object in the request.
 </p></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>querySpec</code> - </dd>
<dd><code>outputstream</code> - </dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="InvalidQueryException.html" title="class in nl.naturalis.nba.api">InvalidQueryException</a></code></dd>
<dd><code><a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/io/IOException.html?is-external=true" title="class or interface in java.io" class="externalLink">IOException</a></code></dd>
</dl>
</li>
</ul>
<a id="count(nl.naturalis.nba.api.QuerySpec)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>count</h4>
<pre class="methodSignature">long&nbsp;count&#8203;(<a href="QuerySpec.html" title="class in nl.naturalis.nba.api">QuerySpec</a>&nbsp;querySpec)
    throws <a href="InvalidQueryException.html" title="class in nl.naturalis.nba.api">InvalidQueryException</a></pre>
<div class="block"><p>
 Returns the number of documents conforming to the provided query
 specification. You may specify <code>null</code> for the <code>querySpec</code>
 argument if you simply want a total document count. Otherwise you should only
 set the query conditions and (possibly) the <a href="LogicalOperator.html" title="enum in nl.naturalis.nba.api"><code>logical
 operator</code></a> on the <code>QuerySpec</code>. Setting anything else on the
 <code>QuerySpec</code> has no effect.
 </p>
 <h5>REST API</h5>
 <p>
 The NBA REST API exposes this method through a GET or POST request with the
 following endpoint:
 </p>
 <p>
 <code>
 https://api.biodiversitydata.nl/v2/&lt;document-type&gt;/count
 </code>
 </p>
 <p>
 For example:
 </p>
 <p>
 <code>
 https://api.biodiversitydata.nl/v2/taxon/count<br>
 https://api.biodiversitydata.nl/v2/specimen/count/?sourceSystem.code=BRAHMS
 </code>
 </p>
 <p>
 See <a href="QuerySpec.html" title="class in nl.naturalis.nba.api"><code>QuerySpec</code></a> for an explanation of how to encode the
 <code>QuerySpec</code> object in the request.
 </p></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>querySpec</code> - </dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="InvalidQueryException.html" title="class in nl.naturalis.nba.api">InvalidQueryException</a></code></dd>
</dl>
</li>
</ul>
<a id="countDistinctValues(java.lang.String,nl.naturalis.nba.api.QuerySpec)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>countDistinctValues</h4>
<pre class="methodSignature">long&nbsp;countDistinctValues&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/String.html?is-external=true" title="class or interface in java.lang" class="externalLink">String</a>&nbsp;field,
                         <a href="QuerySpec.html" title="class in nl.naturalis.nba.api">QuerySpec</a>&nbsp;querySpec)
                  throws <a href="InvalidQueryException.html" title="class in nl.naturalis.nba.api">InvalidQueryException</a></pre>
<div class="block"><p>
 Returns the distinct number of values for the given field. You may specify a
 <code>querySpec</code> argument if you're interested in just the distinct values
 of a (limited) set of documents. You may specify <code>null</code> for the
 <code>querySpec</code> argument if you simply want a total document count.
 Otherwise you should only set the query conditions and (possibly) the
 <a href="LogicalOperator.html" title="enum in nl.naturalis.nba.api"><code>logical operator</code></a> on the <code>QuerySpec</code>. Setting
 anything else on the <code>QuerySpec</code> has no effect.
 </p>
 <h5>REST API</h5>
 <p>
 The NBA REST API exposes this method through a GET or POST request with the
 following endpoint:
 </p>
 <p>
 <code>
 https://api.biodiversitydata.nl/v2/&lt;document-type&gt;/countDistinctValues/{forField}
 </code>
 </p>
 <p>
 For example:
 </p>
 <p>
 <code>
 https://api.biodiversitydata.nl/v2/taxon/countDistinctValues/defaultClassification.genus<br>
 https://api.biodiversitydata.nl/v2/specimen/countDistinctValues/collectionType/?sourceSystem.code=CRS
 </code>
 </p>
 <p>
 See <a href="QuerySpec.html" title="class in nl.naturalis.nba.api"><code>QuerySpec</code></a> for an explanation of how to encode the
 <code>QuerySpec</code> object in the request.
 </p></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>field</code> - </dd>
<dd><code>querySpec</code> - </dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="InvalidQueryException.html" title="class in nl.naturalis.nba.api">InvalidQueryException</a></code></dd>
</dl>
</li>
</ul>
<a id="countDistinctValuesPerGroup(java.lang.String,java.lang.String,nl.naturalis.nba.api.QuerySpec)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>countDistinctValuesPerGroup</h4>
<pre class="methodSignature"><a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/util/List.html?is-external=true" title="class or interface in java.util" class="externalLink">List</a>&lt;<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/util/Map.html?is-external=true" title="class or interface in java.util" class="externalLink">Map</a>&lt;<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/String.html?is-external=true" title="class or interface in java.lang" class="externalLink">String</a>,&#8203;<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/Object.html?is-external=true" title="class or interface in java.lang" class="externalLink">Object</a>&gt;&gt;&nbsp;countDistinctValuesPerGroup&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/String.html?is-external=true" title="class or interface in java.lang" class="externalLink">String</a>&nbsp;forGroup,
                                                           <a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/String.html?is-external=true" title="class or interface in java.lang" class="externalLink">String</a>&nbsp;forField,
                                                           <a href="QuerySpec.html" title="class in nl.naturalis.nba.api">QuerySpec</a>&nbsp;querySpec)
                                                    throws <a href="InvalidQueryException.html" title="class in nl.naturalis.nba.api">InvalidQueryException</a></pre>
<div class="block"><p>
 Returns the distinct number of values for the given field (<i>forField</i>),
 grouped by the second field (<i>forGroup</i>) you have specified. The result
 is a <a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/util/List.html?is-external=true" title="class or interface in java.util" class="externalLink"><code>List</code></a> in which each item consists of 2 <a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/util/Map.html?is-external=true" title="class or interface in java.util" class="externalLink"><code>Map</code></a>s: the first
 containing the group name (key) and the distinct group value (value); the
 second containing the field name (key) and the number of distinct values for
 this field (value), within this group.
 </p>

 <pre>
 [
   {"&lt;<i>forGroup</i>&gt;":"&lt;<i>distinct value a</i>&gt;","&lt;<i>forField</i>&gt;":&lt;<i>distinct count 1</i>&gt;},
   {"&lt;<i>forGroup</i>&gt;":"&lt;<i>distinct value b</i>&gt;","&lt;<i>forField</i>&gt;":&lt;<i>distinct count 2</i>&gt;},
   [...]
   {"&lt;<i>forGroup</i>&gt;":"&lt;<i>distinct value z</i>&gt;","&lt;<i>forField</i>&gt;":&lt;<i>distinct count n</i>&gt;}
 ]
 </pre>

 <p>
 You may specify a <code>querySpec</code> argument if you're interested in just the
 distinct values of a specific set of documents. If you don't include a
 <code>querySpec</code> argument, you will get a summary of all documents.
 </p>

 <p>
 By default, the result will be sorted descending by the distinct field value
 count. You may choose to change the sorting by including the field you're
 using to group the results, as the sort field in the <code>querySpec</code>:
 </p>

 <pre>
 "sortFields" : [ { "path" : "[<i>forGroup</i>]", "sortOrder" : "ASC|DESC" } ]
 </pre>

 Default result size is 10. You can override this by including the desired
 result size in the <code>querySpec</code>:

 <pre>
 "size" : <i>n</i>
 </pre>

 If you have a large result set, you may choose to combine <code>size</code> with
 <code>from</code>. This will allow you to page through the results, by choosing
 the start (<code>from</code>) and the end (<code>size</code>) of the results you'd like
 to see. Include <code>from</code> and <code>size</code> in the <code>querySpec</code>:

 <pre>
 "from" : <i>n</i>,
 "size" : <i>m</i>
 </pre>

 <p>
 NOTE: limiting the result view like this, will not reduce the response time.
 At least, it does at the top end of the result list, but not at the bottom
 end. A request for the final results of the set, will take approximately as
 long as a request for the entire result set. The gain you do have, is the
 recuced amount of data that will be returned by your request.
 </p>

 <p>
 Furthermore, the maximum resultsize is 10 000. If you try to go past that,
 for instance by using <code>from</code> and <code>size</code>, a
 <code>InvalidQueryException</code> will be thrown.
 </p>

 <h5>REST API</h5>
 <p>
 The NBA REST API exposes this method through a GET or POST request with the
 following endpoint:
 </p>
 <p>
 <code>
 https://api.biodiversitydata.nl/v2/&lt;document-type&gt;/countDistinctValuesPerGroup/{forGroup}/{forField}
 </code>
 </p>
 <p>
 For example:
 </p>
 <p>
 <code>
 https://api.biodiversitydata.nl/v2/taxon/countDistinctValuesPerGroup/[<i>field1</i>]/[<i>field2</i>]<br>
 https://api.biodiversitydata.nl/v2/specimen/countDistinctValuesPerGroup/collectionType/sourceSystem.code
 </code>
 </p>
 <p>
 See <a href="QuerySpec.html" title="class in nl.naturalis.nba.api"><code>QuerySpec</code></a> for an explanation of how to encode the
 <code>QuerySpec</code> object in the request.
 </p></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>forGroup</code> - </dd>
<dd><code>forField</code> - </dd>
<dd><code>querySpec</code> - </dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="InvalidQueryException.html" title="class in nl.naturalis.nba.api">InvalidQueryException</a></code></dd>
</dl>
</li>
</ul>
<a id="getDistinctValues(java.lang.String,nl.naturalis.nba.api.QuerySpec)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getDistinctValues</h4>
<pre class="methodSignature"><a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/util/Map.html?is-external=true" title="class or interface in java.util" class="externalLink">Map</a>&lt;<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/String.html?is-external=true" title="class or interface in java.lang" class="externalLink">String</a>,&#8203;<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/Long.html?is-external=true" title="class or interface in java.lang" class="externalLink">Long</a>&gt;&nbsp;getDistinctValues&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/String.html?is-external=true" title="class or interface in java.lang" class="externalLink">String</a>&nbsp;forField,
                                         <a href="QuerySpec.html" title="class in nl.naturalis.nba.api">QuerySpec</a>&nbsp;querySpec)
                                  throws <a href="InvalidQueryException.html" title="class in nl.naturalis.nba.api">InvalidQueryException</a></pre>
<div class="block"><p>
 Returns the unique values of the specified field. The result is returned as a
 <a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/util/Map.html?is-external=true" title="class or interface in java.util" class="externalLink"><code>Map</code></a> with each key specifying one of the unique values and its value
 the document count (the number of documents for which the specified field has
 that value).
 <p>

 <p>
 You may specify <code>null</code> for the <code>querySpec</code> argument if you simply
 want a total document count. Otherwise you should only set the query
 conditions and (possibly) the <a href="LogicalOperator.html" title="enum in nl.naturalis.nba.api"><code>logical operator</code></a> on the
 <code>QuerySpec</code>.
 </p>

 <p>
 By default, the result will be sorted descending by document count. You can
 choose to sort the result by the value of the field name by including that as
 sort field in the <code>querySpec</code>:
 </p>

 <pre>
 "sortFields" : [ { "path" : "[<i>forField</i>]", "sortOrder" : "ASC|DESC" } ]
 </pre>

 <p>
 Note that if the specified field is a <a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/util/Collection.html?is-external=true" title="class or interface in java.util" class="externalLink"><code>Collection</code></a> or an array, the sum
 of the document counts may add up to more than the total number of documents
 in the index.
 </p>


 <h5>REST API</h5>

 <p>
 The NBA REST API exposes this method through a GET request with the following
 endpoint:
 </p>

 <p>
 <code>
 https://api.biodiversitydata.nl/v2/&lt;document-type&gt;/getDistinctValues/{forField}
 </code>
 </p>
 <p>
 For example:
 </p>
 <p>
 <code>
 https://api.biodiversitydata.nl/v2/specimen/getDistinctValues/recordBasis<br>
 </code>
 </p>
 <p>
 See <a href="QuerySpec.html" title="class in nl.naturalis.nba.api"><code>QuerySpec</code></a> for an explanation of how to encode the
 <code>QuerySpec</code> object in the request.
 </p></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>forField</code> - </dd>
<dd><code>querySpec</code> - </dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="InvalidQueryException.html" title="class in nl.naturalis.nba.api">InvalidQueryException</a></code></dd>
</dl>
</li>
</ul>
<a id="getDistinctValuesPerGroup(java.lang.String,java.lang.String,nl.naturalis.nba.api.QuerySpec)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>getDistinctValuesPerGroup</h4>
<pre class="methodSignature"><a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/util/List.html?is-external=true" title="class or interface in java.util" class="externalLink">List</a>&lt;<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/util/Map.html?is-external=true" title="class or interface in java.util" class="externalLink">Map</a>&lt;<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/String.html?is-external=true" title="class or interface in java.lang" class="externalLink">String</a>,&#8203;<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/Object.html?is-external=true" title="class or interface in java.lang" class="externalLink">Object</a>&gt;&gt;&nbsp;getDistinctValuesPerGroup&#8203;(<a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/String.html?is-external=true" title="class or interface in java.lang" class="externalLink">String</a>&nbsp;forGroup,
                                                         <a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/lang/String.html?is-external=true" title="class or interface in java.lang" class="externalLink">String</a>&nbsp;forField,
                                                         <a href="QuerySpec.html" title="class in nl.naturalis.nba.api">QuerySpec</a>&nbsp;querySpec)
                                                  throws <a href="InvalidQueryException.html" title="class in nl.naturalis.nba.api">InvalidQueryException</a></pre>
<div class="block"><p>
 Returns the distinct values and their document count of the specified field
 (<i>forField</i>), grouped by a second specified field (<i>forGroup</i>). The
 result is returned as a <a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/util/List.html?is-external=true" title="class or interface in java.util" class="externalLink"><code>List</code></a> of <a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/util/Map.html?is-external=true" title="class or interface in java.util" class="externalLink"><code>Map</code></a>s. Each <code>List</code> item
 contains 3 <code>Map</code>s. The first map has as key the name of the field used
 to group the result, and its value as value. The second map has as key the
 label "count", and the document count as value. The last map of the
 <code>List</code> has as key the label "values", and as value a <code>List</code>
 containing the distinct values and their document counts. The structure of
 the latter <code>List</code> is similar to that of the <code>List</code> returned by a
 <code>countDistinctValuesPerGroup()</code>: each list item consists of 2
 <code>Map</code>s: the first, having the <i>forField</i> as key, and a distinct
 value as its value; the second, the label "count" as key, and the document
 count as value.
 </p>

 <pre>
 [
  {
   "&lt;<i>forGroup</i>&gt;":"&lt;<i>distinct group value A</i>&gt;",
   "count": &lt;<i>distinct group count 1</i>&gt;,
   "values": [
      {
        "&lt;<i>forField</i>&gt;":"&lt;<i>distinct value a</i>&gt;",
        "count": &lt;<i>distinct count 1</i>&gt;
      },
      {
        "&lt;<i>forField</i>&gt;":"&lt;<i>distinct value b</i>&gt;",
        "count": &lt;<i>distinct count 2</i>&gt;
      },
      [...]
      {
        "&lt;<i>forField</i>&gt;":"&lt;<i>distinct value z</i>&gt;",
        "count": &lt;<i>distinct count n</i>&gt;
      },
   ],
   "&lt;<i>forGroup</i>&gt;":"&lt;<i>distinct group value B</i>&gt;",
   "count": &lt;<i>distinct group count 2</i>&gt;,
   "values": [
      {
        "&lt;<i>forField</i>&gt;":"&lt;<i>distinct value a</i>&gt;",
        "count": &lt;<i>distinct count 1</i>&gt;
      },
      {
        "&lt;<i>forField</i>&gt;":"&lt;<i>distinct value b</i>&gt;",
        "count": &lt;<i>distinct count 2</i>&gt;
      },
      [...]
      {
        "&lt;<i>forField</i>&gt;":"&lt;<i>distinct value z</i>&gt;",
        "count": &lt;<i>distinct count n</i>&gt;
      }
   ],
   [...]
 }
 </pre>

 <p>
 NOTE: you may think that the sum of all counts of the distinct field values,
 will add up to the count of the distinct field value used to group the
 results. This is not true though! At least, not necessarily. The count of
 both summaries is independent of each other. When each record exactly one
 occurence of both fields (<i>forField</i> and <i>forGroup</i>), then the
 counts will add up
 </p>
 . If the number of occurences of the specified fields differ, then the counts
 are unrelated.
 </p>

 <p>
 You may specify a <code>querySpec</code> argument if you're interested in just the
 distinct values of a specific set of documents. If you don't include a
 <code>querySpec</code> argument, you will get a summary of all documents.
 </p>

 <p>
 By default, the result will be sorted descending by the distinct field value
 count. You can choose to change the sorting by including the <i>forField</i>
 and/or the <i>forGroup</i> as sort field(s) in the <code>querySpec</code>:
 </p>

 <pre>
 "sortFields" : [ { "path" : "[<i>forGroup</i>]", "sortOrder" : "ASC|DESC" } ]
 </pre>

 <p>
 The default result size is 10. You can override this by including the desired
 result size in the <code>querySpec</code>:
 </p>

 <pre>
 "size" : <i>n</i>
 </pre>

 If you have a large result set, you may choose to combine <code>size</code> with
 <code>from</code>. This will allow you to page through the results, by choosing
 the start (<code>from</code>) and the end (<code>size</code>) of the results you'd like
 to see. Include <code>from</code> and <code>size</code> in the <code>querySpec</code>:

 <pre>
 "from" : <i>n</i>,
 "size" : <i>m</i>
 </pre>

 <p>
 NOTE: limiting the result view like this, will not reduce the response time.
 At least, it does at the top end of the result list, but not at the bottom
 end. A request for the final results of the set, will take approximately as
 long as a request for the entire result set. The gain you do have, is the
 recuced amount of data that will be returned by your request.
 </p>

 <p>
 Furthermore, the maximum resultsize is 10 000. If you try to go past that,
 for instance by using <code>from</code> and <code>size</code>, a
 <code>InvalidQueryException</code> will be thrown.
 </p>

 <h5>REST API</h5>
 <p>
 The NBA REST API exposes this method through a GET request with the following
 endpoint:
 </p>
 <p>
 <code>
 https://api.biodiversitydata.nl/v2/&lt;document-type&gt;/getDistinctValuesPerGroup/{forGroup}/{forField}
 </code>
 </p>
 <p>
 For example:
 </p>
 <p>
 <code>
 https://api.biodiversitydata.nl/v2/specimen/getDistinctValuesPerGroup/sourceSystem.code/recordBasis<br>
 </code>
 </p>
 <p>
 See <a href="QuerySpec.html" title="class in nl.naturalis.nba.api"><code>QuerySpec</code></a> for an explanation of how to encode the
 <code>QuerySpec</code> object in the request.
 </p></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>forGroup</code> - </dd>
<dd><code>forField</code> - </dd>
<dd><code>querySpec</code> - </dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="InvalidQueryException.html" title="class in nl.naturalis.nba.api">InvalidQueryException</a></code></dd>
</dl>
</li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
</div>
</main>
<!-- ========= END OF CLASS DATA ========= -->
<footer role="contentinfo">
<nav role="navigation">
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a id="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/INbaAccess.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</nav>
</footer>
</body>
</html>
